IMPLEMENTATION MODULE Cola;

FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
FROM Cadena IMPORT Copiar;   (* NO ES NECESARIO; BASTA CON LA ASIGNACION *)
TYPE
   Tcola=POINTER TO CABECERA;
   PCAJA=POINTER TO CAJA;
   CABECERA=RECORD
                 frente:PCAJA;
                 final:PCAJA;
   END;
   CAJA=RECORD
             men:Tcadena;
             sig:PCAJA;
   END;

PROCEDURE CrearCola(VAR c:Tcola;VAR error:ERROR);
          BEGIN
              error:=SinError;
              IF Available(SIZE(c^)) THEN
                NEW(c);
                c^.frente:=NIL;
                c^.final:=NIL;
              ELSE
                error:=NoMemoria
              END;
END CrearCola;

PROCEDURE ColaVacia(c:Tcola;VAR error:ERROR):BOOLEAN;
VAR vacia:BOOLEAN;
          BEGIN
              error:=SinError;
              IF c=NIL THEN
                 error:=NoCreada;
                 vacia:=FALSE;
              ELSE
                 vacia:=c^.frente=NIL;
              END;
              RETURN vacia;
END ColaVacia;

PROCEDURE MeterCola(VAR c:Tcola;mensaje:Tcadena;VAR error:ERROR);
          VAR
            aux:PCAJA;
          BEGIN
            error:=SinError;
            IF c=NIL THEN
               error:=NoCreada;
            ELSIF NOT Available(SIZE(aux^)) THEN
               error:=NoMemoria
            ELSE
              NEW(aux);
              aux^.men:=mensaje;
              aux^.sig:=NIL;
              IF c^.frente=NIL THEN
                 c^.frente:=aux;
                 c^.final:=aux;
              ELSE
                 c^.final^.sig:=aux;
                 c^.final:=aux;
              END;
            END;
END MeterCola;

PROCEDURE SacarCola(VAR c:Tcola;VAR mensaje:Tcadena;VAR error:ERROR);
          VAR
            aux:PCAJA;
          BEGIN
            error:=SinError;
            IF c=NIL THEN
               error:=NoCreada;
            ELSIF c^.frente=NIL THEN
               error:=Vacia
            ELSE
               aux:=c^.frente;
               c^.frente:=aux^.sig;
               mensaje:=aux^.men;    (*Por ahora se permite la asignacion entre cadenas*)
               DISPOSE(aux);
            END;
END SacarCola;

PROCEDURE DestruirCola(VAR c:Tcola;VAR error:ERROR);
          VAR
            aux:PCAJA;
          BEGIN
            error:=SinError;
            IF c=NIL THEN
               error:=NoCreada;
            ELSE
              WHILE c^.frente#NIL DO
                 aux:=c^.frente;
                 c^.frente:=aux^.sig;
                 DISPOSE(aux);
              END;
              DISPOSE(c);    (* OJO, hay que destruir la cabecera. No olvidarse *)
            END;
END DestruirCola;


END Cola.